VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "PDH_VBDemo - Matt Pietrek 1998, for MSJ"
   ClientHeight    =   2895
   ClientLeft      =   2445
   ClientTop       =   1515
   ClientWidth     =   6810
   LinkTopic       =   "Form1"
   ScaleHeight     =   2895
   ScaleWidth      =   6810
   Begin VB.OptionButton PerfDetail 
      Caption         =   "Wizard"
      Height          =   255
      Index           =   3
      Left            =   5400
      TabIndex        =   5
      Top             =   1080
      Value           =   -1  'True
      Width           =   1215
   End
   Begin VB.OptionButton PerfDetail 
      Caption         =   "Expert"
      Height          =   255
      Index           =   2
      Left            =   5400
      TabIndex        =   4
      Top             =   840
      Width           =   1215
   End
   Begin VB.OptionButton PerfDetail 
      Caption         =   "Advanced"
      Height          =   255
      Index           =   1
      Left            =   5400
      TabIndex        =   3
      Top             =   600
      Width           =   1215
   End
   Begin VB.OptionButton PerfDetail 
      Caption         =   "Novice"
      Height          =   255
      Index           =   0
      Left            =   5400
      TabIndex        =   2
      Top             =   360
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Caption         =   "Detail Level"
      Height          =   1335
      Left            =   5280
      TabIndex        =   6
      Top             =   120
      Width           =   1455
   End
   Begin VB.CommandButton cmdAddCounter 
      Caption         =   "Add Counter..."
      Height          =   495
      Left            =   5280
      TabIndex        =   1
      Top             =   2280
      Width           =   1335
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   120
      Top             =   2400
   End
   Begin VB.Label Label1 
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'--------------------------------------------------------------
' Matt Pietrek
' Microsoft Systems Journal, March 1998
' Program: PDH_VBDemo
' FILE: PDH_VBDemo.FRM
'--------------------------------------------------------------

Option Explicit

' Declare a structure to correlate a counter path to its
' associated handle values
Private Type CounterInfo
    hCounter As Long
    strName As String
End Type

Dim hQuery As Long

' Make room for 100 counters.  Yeah, it probably should be a
' collection or something...
Dim Counters(0 To 99) As CounterInfo

' The array index where the next CounterInfo will be added
Dim currentCounterIdx As Long

' The current level of geeky counters to show in the
' PdhVbGetOneCounterPath dialog box
Dim iPerformanceDetail As PERF_DETAIL

'-------------------------------------------------------------
' Calls PdhVbAddCounter, then appends the counter path and
' handle to the Counters array.
'-------------------------------------------------------------
Public Sub AddCounter(strCounterName As String, hQuery As Long)
    Dim pdhStatus As PDH_STATUS
    Dim hCounter As Long
    
    ' Associate the counter path to the query
    pdhStatus = PdhVbAddCounter(hQuery, strCounterName, hCounter)
    
    ' Append the path and handle to the Counters array
    Counters(currentCounterIdx).hCounter = hCounter
    Counters(currentCounterIdx).strName = strCounterName
    
    ' Bump up index to be ready for the next addition
    currentCounterIdx = currentCounterIdx + 1
End Sub

'--------------------------------------------------------------
' Displays the counter names and values for each added counter.
' The display string is built by iterating through all of the
' added counters, and using CR-LF to split counter value
' out one to a line.  The final result is dumped into a label
' (static text control.)
'--------------------------------------------------------------
Private Sub UpdateValues()
    Dim dblCounterValue As Double
    Dim pdhStatus As Long
    Dim strInfo As String
    Dim i As Long
    
    ' Get the most recent value for all the added counters
    PdhCollectQueryData (hQuery)
    
    ' For each added counter...
    For i = 0 To (currentCounterIdx - 1)

        ' Get the counter value as a double
        dblCounterValue = _
            PdhVbGetDoubleCounterValue(Counters(i).hCounter, pdhStatus)
                
        ' Verify that when we queried, the returned value was valid
        If (pdhStatus = PDH_CSTATUS_VALID_DATA) _
        Or (pdhStatus = PDH_CSTATUS_NEW_DATA) Then
            
            ' The counter value is valid, so append the counter path and
            ' its value onto the end of a string.  Note the second argument
            ' to Format$, which ensures that fractional part of the number
            ' will be discarded.  This is somewhat cheesy, but it's a lot
            ' more work to get something that's nicer in all cases.
            strInfo = strInfo + Counters(i).strName + " = " + _
                        Format$(dblCounterValue, "0") + Chr$(13) + Chr$(10)
        End If
        
    Next i
       
    Label1 = strInfo    ' Blast the finished string into the text control
End Sub

Private Sub Form_Load()
    Dim pdhStatus As PDH_STATUS
    
    currentCounterIdx = 0   ' Not necesary, but C++ habits die hard
    
    ' Create the query, and verify that the request succeeded.
    ' Bail out if not.
    pdhStatus = PdhOpenQuery(0, 1, hQuery)
    If pdhStatus <> ERROR_SUCCESS Then
        MsgBox "OpenQuery failed"
        End
    End If
    
    ' Add some interesting counters as defaults
    AddCounter "\Process(_total)\Thread Count", hQuery
    AddCounter "\Memory\Committed Bytes", hQuery
    AddCounter "\Processor(0)\% Processor Time", hQuery
    AddCounter "\System\Context Switches/Sec", hQuery
    
    UpdateValues    ' Force an immediate display of the counter values
    
    PerfDetail_Click (3)    ' Fake a click on the "Wizard" radio button
    
    ' Now that everything is set up, we can enable the 1 second timer.
    ' It's disabled up to this point.
    Timer1.Enabled = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Timer1.Enabled = False  ' Don't need periodic updates anymore
    
    PdhCloseQuery (hQuery)  ' Free the query
End Sub

Private Sub cmdAddCounter_Click()
    Dim cbLen As Long
    Dim strCounterPath As String * 256
    Dim strCounterPath2 As String
    
    ' Display the dialog to pick one counter.  strCounterPath is a buffer
    ' of 256 charaters
    cbLen = PdhVbGetOneCounterPath(strCounterPath, 256, iPerformanceDetail, _
                                    "MSJ PDH.DLL Demo - Matt Pietrek, 1998")
    
    ' If nothing was selected, bail out
    If cbLen = 0 Then Exit Sub
    
    ' Make a string that contains only the valid characters that were written
    ' to by the call to PdhVbGetOneCounterPath
    strCounterPath2 = Left$(strCounterPath, cbLen)
    
    ' Add the new counter to the query, and to the Counters array
    AddCounter strCounterPath2, hQuery
    
    UpdateValues    ' Force an immediate display update
End Sub

Private Sub PerfDetail_Click(Index As Integer)
    ' Based upon the radio button that was pressed, set the
    ' iPerformanceDetail variable to the proper enum
    Select Case Index
        Case 0
            iPerformanceDetail = PERF_DETAIL_NOVICE
        Case 1
            iPerformanceDetail = PERF_DETAIL_ADVANCED
        Case 2
            iPerformanceDetail = PERF_DETAIL_EXPERT
        Case 3
            iPerformanceDetail = PERF_DETAIL_WIZARD
End Select
End Sub

Private Sub Timer1_Timer()
    ' Set to trigger once a second.  Update the counter display
    UpdateValues
End Sub
